# Combine Results


rm(list=ls(all=TRUE))


L = 19 # no of outputs+1 


Proposedresult = matrix(NA, nrow=200, ncol = L)
for(i in 1:200){
  a = try(read.table(file=paste("Proposedresult2_run", i, ".txt",sep=""), fill=TRUE), silent=T)
  if((a[1]==i)[1]){
    Proposedresult[i,1:18] = as.numeric(a[1,])
    Proposedresult[i,19] = as.numeric(a[2,1])
  }
}

estimate=Proposedresult[,2:19]
estimate=t(estimate)

#### Initial values for all parameters.
theta.old<-c(1,2,2,2,0.5,0.3,0.2,0.1,0.2) #AR2 model
true.theta<-theta.old
mle<-cbind(estimate[1,],estimate[2,],estimate[3,],estimate[4,],estimate[5,],estimate[6,],estimate[7,],estimate[8,],estimate[9,])
se<-cbind(estimate[10,],estimate[11,],estimate[12,],estimate[13,],estimate[14,],estimate[15,],estimate[16,],estimate[17,],estimate[18,])
## Estimation of Bias, Root mean square error (RMSE).
theta<-apply(mle,2,mean) 
SE<-apply(mle,2,sd)
bias<-round(theta-theta.old,5)
RMSE<-sqrt((apply(mle,2,var))+(bias^2))
n=350;q=5
CR<-c()
for (i in 1:9)
{
  ll=mle[,i]-1.96*SE[i]
  ul=mle[,i]+1.96*SE[i]
  coverage=((ll<=true.theta[i]) & (ul>=true.theta[i]))
  CR[i]<-mean(coverage) # Coverage of C.I for true theta 
}


table_proposed<-data.frame(bias,RMSE,CR)
round(table_proposed,4)