
#########################################################
# Perform a Monte-Carlo study using parallel computing
#########################################################

#require(parallel)
library(parallel)
ncores <- 28
cl <- makeCluster(ncores)

# add packages
msg <- clusterEvalQ(cl = cl, expr = {
source("ProposedMethod_Nonstationary1.R")
Proposed.MC = function(m, n,q){
set.seed(12345+m) 
#set.seed(12345) 
Proposedresult2=Proposed(n,q,0.8)
res=c(m, Proposedresult2)
write(res, file=paste("ProposedresultNonstationaryIVFixed_run", m, ".txt",sep=""), ncol=18, append=T)
return(res)
  }
})

system.time({
 Proposedresult2 <- parSapply(cl = cl, X = 1:200, FUN = function(m) {
 Proposed.MC(m, n=350,q=5)
  })
})

stopCluster(cl)

save(Proposedresult2, file="Proposedresult_NonstationaryIVFixedq5.Rdata")


    